Ipelib: ipe::PdfParser Class Reference

Ipelib

Public Member Functions | List of all members
ipe::PdfParser Class Reference
Ipe Base

`#include <ipepdfparser.h>`

## Public Member Functions
| PdfParser (DataSource &source)
void | getChar ()
bool | eos () const noexcept
PdfToken | token () const noexcept
void | getToken ()
PdfObj * | getObject ()
PdfObj * | getObjectDef ()
PdfDict * | getTrailer ()
void | skipXRef ()

## Detailed Description

PDF parser.

The parser understands the syntax of PDF files, but very little of its semantics. It is meant to be able to parse PDF documents created by Ipe for loading, and to extract information from PDF files created by Pdflatex or Xelatex.

The parser reads a PDF file sequentially from front to back, ignores the contents of 'xref' sections, stores only generation 0 objects, and stops after reading the first 'trailer' section (so it cannot deal with files with incremental updates). It cannot handle stream objects whose /Length entry has been deferred (using an indirect object).

## Constructor & Destructor Documentation

## ◆ PdfParser()

PdfParser::PdfParser | ( | DataSource & | source | ) |

Construct with a data source.

Referenced by ipe::PdfDict::inflate().

## Member Function Documentation

## ◆ getChar()

void ipe::PdfParser::getChar | ( |  | ) |
| inline

Referenced by ipe::PdfFile::parseObjectStream().

## ◆ eos()

bool ipe::PdfParser::eos | ( |  | ) | const
| inlinenoexcept

Referenced by ipe::CairoPainter::doDrawText().

## ◆ token()

PdfToken ipe::PdfParser::token | ( |  | ) | const
| inlinenoexcept

Referenced by ipe::CairoPainter::doDrawText(), ipe::PdfFile::parse(), and ipe::PdfFile::parseObjectStream().

## ◆ getToken()

void PdfParser::getToken | ( |  | ) |

Read the next token from the input stream.

References ipe::PdfObj::dict(), ipe::PdfToken::EArrayBg, ipe::PdfToken::EArrayEnd, ipe::PdfToken::EDictBg, ipe::PdfToken::EDictEnd, ipe::PdfToken::EErr, ipe::PdfToken::EFalse, ipe::PdfToken::EName, ipe::PdfToken::ENull, ipe::PdfToken::ENumber, ipe::PdfToken::EOp, ipe::PdfToken::EString, ipe::PdfToken::EStringBinary, ipe::PdfToken::ETrue, ipe::PdfToken::iString, ipe::PdfObj::name(), ipe::PdfObj::number(), ipe::PdfObj::ref(), ipe::Platform::toDouble(), and ipe::PdfNumber::value().

Referenced by ipe::CairoPainter::doDrawText(), and ipe::PdfFile::parseObjectStream().

## ◆ getObject()

PdfObj * PdfParser::getObject | ( |  | ) |

Read one object from input stream.

References ipe::PdfToken::EArrayBg, ipe::PdfToken::EDictBg, ipe::PdfToken::EErr, ipe::PdfToken::EFalse, ipe::PdfToken::EName, ipe::PdfToken::ENull, ipe::PdfToken::ENumber, ipe::PdfToken::EString, ipe::PdfToken::EStringBinary, ipe::PdfToken::ETrue, ipe::PdfToken::iString, ipe::PdfToken::iType, ipe::String::substr(), and ipe::Platform::toDouble().

Referenced by ipe::CairoPainter::doDrawText(), and ipe::PdfFile::parseObjectStream().

## ◆ getObjectDef()

PdfObj * PdfParser::getObjectDef | ( |  | ) |

Parse an object definition (current token is object number).

References ipe::PdfToken::ENumber, and ipe::PdfToken::EOp.

Referenced by ipe::PdfFile::parse().

## ◆ getTrailer()

PdfDict * PdfParser::getTrailer | ( |  | ) |

Parse trailer dictionary (current token is 'trailer')

References ipe::PdfToken::EDictBg.

Referenced by ipe::PdfFile::parse().

## ◆ skipXRef()

void PdfParser::skipXRef | ( |  | ) |

Skip xref table (current token is 'xref')

Referenced by ipe::PdfFile::parse().

The documentation for this class was generated from the following files:

- ipepdfparser.h
- ipepdfparser.cpp